#include "defs.h"
#include "anf.h"


t_handle
glue_anf_elt_mult WITH_7_ARGS(
        t_handle,       ring,
        integer_big,    a,
        t_int,          it1,
        integer_big,    b,
        t_int,          it2,
        integer_big *,  res,
        t_int *,        it3
)
{
	*res = anf_elt_mult(ring,a,b);
	*it3 = 0;
}



public t_logical glue_anf_elt_eq (s1, e1, it1, s2, e2, it2)
t_handle s1, e1, s2, e2;
t_int it1, it2;
{
	return anf_elt_equal(s1, e1, e2);
}

public t_handle
glue_anf_elt_add(s1, e1, e2, res_e)
t_handle s1, e1, e2, *res_e;
{
	*res_e = anf_elt_add(s1, e1, e2);
}

public t_handle
glue_anf_elt_subtract(s1, e1, e2, res_e)
t_handle s1, e1, e2, *res_e;
{
	*res_e = anf_elt_subtract(s1, e1, e2);
}

public t_handle
glue_anf_elt_negate(s, e, res_e)
t_handle s, e, *res_e;
{
	*res_e = anf_elt_negate(s, e);
}

public t_handle
glue_anf_elt_power(s1, e1, it1, n, res_s, res_e, res_it)
t_handle s1, e1, it1, n, *res_s, *res_e, *res_it;
{
	*res_e = anf_elt_power(s1, e1, n);
	*res_s = order_incref(s1);
}

t_handle
glue_anf_elt_incref(s1, e1)
t_handle	s1, e1;
{
	return anf_elt_incref(e1);
}

t_void
glue_anf_elt_delete(s1, e1)
t_handle	s1, *e1;
{
	block_declarations;
	anf_elt_delete(s1, e1);
}

public t_handle
glue_anf_elt_slash(s1, e1, e2)
t_handle s1, e1, e2;
{
	return anf_elt_div(s1, e1, e2);
}

public t_handle
glue_anf_elt_is_one(str, elt)
t_handle str, elt;
{
	return anf_elt_is_one(str, elt);
}

public t_handle
glue_anf_elt_is_zero(str, elt)
t_handle str, elt;
{
	return anf_elt_is_zero(str, elt);
}

public t_handle
glue_anf_elt_is_minus_one(str, elt)
t_handle str, elt;
{
	return anf_elt_is_minus1(str, elt);
}

public t_handle
glue_anf_elt_inverse(str, elt, it, res_elt, res_it)
t_handle str, elt, it, *res_elt, *res_it;
{
    *res_it = 0;
    *res_elt = anf_elt_inverse(str, elt);
}
