/******************************************************************************
  anf_ideal_z_assure.c
******************************************************************************/
 
#include "stdio.h"        
#include "kant.h"
#include "anf.h"

t_void
anf_ideal_z_assure WITH_2_ARGS(
	order,		ord,
	anf_ideal,	id
)
/*******************************************************************************
 
Description:
             
	If not yet given, this routine creates a Z-Basis-
	Presentation of id .
  
Calling sequence:
 
        anf_ideal_z_assure(ord, id);
 
        order   	ord:        order over which id is defined
        anf_ideal       id:	    ideal to be in Z-Basis-Presentation
 
History:

	92-06-25 CO     first version

*******************************************************************************/
{       
	block_declarations;
 
	order_must_be_over_z(ord);

	if(!anf_ideal_is_z(id)) anf_ideal_2_z(ord, id);

	return;
}

