#include "kant.h" 
#include "z.e" 
#include "anf.h" 

anf_elt
anf_power WITH_3_ARGS(
        order,          ord,
        anf_elt,        alpha,
        integer_big,    expo
)

/*******************************************************************************
 
anf_power.c
 
KW Oktober 1991
Last modification: 04.11.91
 
*******************************************************************************/

{
        block_declarations;

        anf_elt         tempa,tempb,tempc;
        integer_big     expo_abs,q,r;

        tempa = anf_elt_incref(alpha);

        tempb = 1;

        if (integer_is_single(expo))
        {
                expo_abs = (expo >= 0) ? expo : -expo;;

                for ( ; expo_abs != 0 ; expo_abs = expo_abs >> 1)
                {
                        if (expo_abs & 1) 
                        {
                                tempc = tempb;
                                tempb = anf_mult(ord,tempa,tempb);
                                anf_elt_delref(ord,&tempc);
                        }
                        tempc = tempa;
                        tempa = anf_mult(ord,tempa,tempa);
                        anf_elt_delref(ord,&tempc);
                }                

                anf_elt_delref(ord,&tempa); 

                if (expo < 0)
                {
                        tempc = tempb;
                        tempb = anf_inverse(ord,tempb);
                        anf_elt_delref(ord,&tempc);
                }

                return (tempb); 
        }
        else
        {
                if (integer_compare(expo,0) == -1) 
                {
                        expo_abs = integer_negate(expo);
                }
                else
                {
                        expo_abs = integer_incref(expo);
                }
                
                while (integer_compare(expo_abs,0))
                {
                        integer_quot_rem(expo_abs,2,&q,&r);
                        integer_delref(expo_abs);
                        expo_abs = q;
                        
                        if (!(integer_compare(r,1)))
                        {
                                tempc = tempb;
                                tempb = anf_mult(ord,tempa,tempb);
                                anf_elt_delref(ord,&tempc);
                        }
                        integer_delref(r);

                        tempc = tempa;
                        tempa = anf_mult(ord,tempa,tempa);
                        anf_elt_delref(ord,&tempc);
                }                

                anf_elt_delref(ord,&tempa); 

                if (integer_compare(expo,0) == -1)
                {
                        tempc = tempb;
                        tempb = anf_inverse(ord,tempb);
                        anf_elt_delref(ord,&tempc);
                }

                return (tempb); 
        }
}
