/*******************************************************************************
  integer_prime_power.c 
********************************************************************************/


#include <stdio.h>
#include "kant.h" 
#include "integer.e" 


integer_big 
integer_prime_power WITH_2_ARGS ( integer_big,       p,
                                  integer_big,       n )
/*******************************************************************************

Description:                               

	calculates an integer prim_power with :
          
              p_exponent-1         p_exponent 
             p             < n <= p           =: prime_power;


Calling sequence:                                      
                                        
        integer_big        p;
        integer_big        n;
        
        integer_big        prime_power; 

            
           prime_power = integer_prime_power (p,n);
       
        The return value is described above.
                                                                     

History:  
                                                               
       MD 91-11-23         : first version                
                                                    
********************************************************************************/
{ 
     integer_big          potenz;
     integer_small        p_exponent;
    

  p_exponent = 0;
  potenz     = 1;

  do
  {               
    potenz = integer_mult (p,potenz);
    p_exponent++;
  }
  while (integer_compare(potenz,n) == -1);
  
  return potenz;
}                             
