#include "defs.h"
#include "ring.h"
#include "integer.e"
#include "mat.h"

void
mat_z_negate_sub WITH_3_ARGS(
	t_handle,	cring,
	matrix,	a,
	matrix	*,	result
)
/*
** *result = -a, where a is a matrix over coefficient ring cring, cring
** is integer ring.
*/
{
	Logical respack;
	t_int		m;
	t_int		n;
	matrix	adash;
	matrix	resultdash;
	t_int		i;

	adash = resultdash = 0;
	respack = mat_result_pkd(cring, *result);
	m = mat_row(a);
	n = mat_col(a);

	mat_alloc_result_unpkd(respack, *result, resultdash, m ,n);
	mat_create_unpkd(cring, a, adash, m, n);

	for (i = 1; i <= m*n; i++)
	{
		mat_entry(resultdash, i) = integer_negate(mat_entry(adash, i));
	}
			
	mat_create_result(cring, respack, *result, resultdash);
	mat_free_unpkd(a, adash);
}


matrix 
mat_z_negate WITH_2_ARGS(
	t_handle,	cring,
	matrix,	a
)
/*
** Returns -a, where a is a matrix over coefficient ring cring, cring is
** integer ring.
*/
{
	matrix	result = 0;
	mat_z_negate_sub(cring, a, &result);
	return result;
}

