#include "defs.h"
#include "principal_ideal.e"

t_pi_elt
principal_ideal_elt_power(ideal, e, n)
t_handle	ideal;
t_pi_elt	e; 
t_int		n;
{

	t_pi_context    context;

        pi_ctx_init(ideal, &context);
        return pi_elt_power_ctx(&context, e, n);
}

t_pi_elt pi_elt_power_ctx(context, e, n)
t_pi_ctx	context;
t_pi_elt	e;
t_int		n;
/* Return e^n * g^(n-1) */
{
        t_handle        ring;
        t_pfh           elt_power;
        t_pfv           elt_delete;
        t_pfh           elt_mult;
	t_pi_elt	res_e;
	t_handle	res_s;
	t_handle	temp, temp1;
	t_int		it;
	t_handle	g;

	ring = m_pi_ctx_ring(context);
	elt_power = m_pi_ctx_elt_power(context);
	elt_mult = m_pi_ctx_elt_mult(context);
	elt_delete = m_pi_ctx_elt_delete(context);
	ASSERT(elt_power);
	ASSERT(elt_mult);
	ASSERT(elt_delete);
	g = m_pi_ctx_generator(context);

	(*elt_mult)(ring, e, 0, g, 0, &temp, &it);
        (*elt_power)(ring, temp,0, n-1, &res_s, &temp1, &it);
	(*elt_mult)(ring, temp1, 0, e, 0, &res_e, &it);
	(*elt_delete)(ring, &temp1);
	(*elt_delete)(ring, &temp);
	return res_e;
}
