#include "defs.h"
#include "principal_ideal.e"

t_handle
principal_ideal_str_add(id1, id2)
t_handle	id1, id2;
{

	t_pi_context    context;

        pi_ctx_init(id1, &context);
        return pi_str_add_ctx(&context, id1, id2);
}

t_handle pi_str_add_ctx(context, id1, id2)
t_pi_ctx	context;
t_handle	id1, id2;
{
        t_handle        ring;
        t_pfh           elt_gcd;
	t_pfv		elt_delete;
	t_pi_elt	res;
	t_handle	g, g1, g2;

	g1 = m_pi_generator(id1);
	g2 = m_pi_generator(id2);
	ring = m_pi_ctx_ring(context);
	elt_gcd = m_pi_ctx_elt_gcd(context);
	elt_delete = m_pi_ctx_elt_delete(context);
	ASSERT(elt_gcd);
	ASSERT(elt_delete);


        g = (*elt_gcd)(ring, g1, g2);
	res = principal_ideal_str_create(ring, g);
	(*elt_delete)(ring, &g);
	return res;
	
}
