#include "kant.h"



t_void
anf_rel_field_basis_create WITH_6_ARGS (order           , ord            , 
                                        order           , rel_ord        ,
                                        t_logical         , index_is_princ ,
                                        anf_elt         , xi             ,
                                        anf_ideal       , b              ,
                                        dyn_arr_handle *, generators        )



{
               block_declarations;

               anf_elt         temp1;
               anf_elt         r_temp1,r_temp2;

               integer_small   n,i;

   
  n = order_abs_degree (ord); /* Ord is a Z - order */ 


  if (index_is_princ)
  {
    *generators                       = dyn_arr_alloc (2+2*n);
    dyn_arr_curr_length (*generators) = 2+2*n;
    dyn_arr_element (*generators,0)   = 2;

    dyn_arr_element (*generators,1)   = xi;


    /* Now store the Z - Basis .. */

    /* First the gen. of o(F). */

    for (i=1;i<=n;i++)
    {
      temp1 = order_basis_elt (ord,i);
      dyn_arr_element (*generators,i+1) = anf_elt_move (ord,temp1,rel_ord);

      anf_elt_delete (ord,&temp1);
    }  

    for (i=1;i<=n;i++)
    {
      temp1   = order_basis_elt (ord,i);
      r_temp1 = anf_elt_move (ord,temp1,rel_ord);
  
      r_temp2 = anf_elt_mult (rel_ord,xi,r_temp1);
      dyn_arr_element (*generators,i+n+1)   = r_temp2;
   
      anf_elt_delete (ord,&temp1);
      anf_elt_delete (rel_ord,&r_temp1);
    }
  }
  else
    { 
      anf_ideal_2_assure (ord,b);
      anf_ideal_z_assure (ord,b);          
          
      r_temp1 = anf_elt_move (ord,anf_ideal_gen1 (b),rel_ord); 
      r_temp2 = anf_elt_move (ord,anf_ideal_gen2 (b),rel_ord);
                                

      *generators                       = dyn_arr_alloc (3+2*n);
      dyn_arr_curr_length (*generators) = 3+2*n;
      dyn_arr_element (*generators,0)   = 3; 
 
      dyn_arr_element (*generators,1)   = anf_elt_mult (rel_ord,xi,r_temp1);
      dyn_arr_element (*generators,2)   = anf_elt_mult (rel_ord,xi,r_temp2);
      

      anf_elt_delete (rel_ord,&r_temp1);  
      anf_elt_delete (rel_ord,&r_temp2);  

      /* Now store the Z - Basis .. */

    /* First the gen. of o(F). */
      for (i=1;i<=n;i++)
      {
        temp1 = order_basis_elt (ord,i);
        dyn_arr_element (*generators,i+2) = anf_elt_move (ord,temp1,rel_ord);

        anf_elt_delete (ord,&temp1);
      }  

      for (i=1;i<=n;i++)
      {
        temp1   = mat_order_col_to_anf_elt (ord,anf_ideal_tran (b),i);
        r_temp1 = anf_elt_move (ord,temp1,rel_ord);
  
        r_temp2 = anf_elt_mult (rel_ord,xi,r_temp1);

        dyn_arr_element (*generators,i+n+2) = r_temp2;
                                     
        anf_elt_delete (ord,&temp1);
        anf_elt_delete (rel_ord,&r_temp1);
      }
   }  


}
