#include "kant.h"


t_void
anf_rel_field_basis_create_index WITH_6_ARGS (order         , ord              ,
                                              faclst        , faclst_sqr_index ,
                                              integer_small , pos_index_my     ,
                                              anf_ideal   * , index            ,
                                              anf_ideal   * , index_2          ,
                                              anf_ideal   * , index_my           )
{
              block_declarations;

              anf_ideal          ideal; 
              faclst             faclst_index;

              integer_small      ideal_power,len,i;

  if (faclst_sqr_index == MEM_NH)
  {
    *index    = anf_ideal_2_create (ord,1,1);
    *index_2  = anf_ideal_incref (*index);
    *index_my = anf_ideal_incref (*index);
 
    if (anf_print_level > 0) 
    {
      puts ("The index : ");

      anf_ideal_2_assure (ord,*index);
      printf ("IDEAL : ");anf_ideal_write (ord,*index);
      puts ("");
  
 
    }
  }
  else
    {   

      len = m_poly_z_faclst_len (faclst_sqr_index);

      faclst_index = m_poly_z_faclst_alloc (len);
      m_poly_z_faclst_len_put (faclst_index,len);
  

      for (i=0;i<len;i++)
      {
        ideal       = m_poly_z_faclst_factor (faclst_sqr_index,i);
        ideal_power = m_poly_z_faclst_power  (faclst_sqr_index,i); 

        m_poly_z_faclst_factor (faclst_index,i) = anf_ideal_incref (ideal);


        m_poly_z_faclst_power (faclst_index,i) = ideal_power / 2;

      }

/* We need all the different parts of the index   */
/* These are in part. :                           */
/*   1) index_2  := gcd ((2),index)               */
/*   2) index_my := index / index_my              */
/*                                                */
/* Certainly we have : index = index_2 * index_my */


      *index_2  = anf_ideal_mult_faclst_range (ord,faclst_index,0,
                                                  pos_index_my);
      *index_my = anf_ideal_mult_faclst_range (ord,faclst_index,
                       pos_index_my,m_poly_z_faclst_len (faclst_index));
      *index    = anf_ideal_mult (ord,*index_2,*index_my);

  
      if (anf_print_level > 0) 
      {
        puts ("The index : ");

        if (anf_print_level > 1)
          anf_ideal_faclst_write (ord,faclst_index);

        anf_ideal_2_assure (ord,*index);
        printf ("IDEAL : ");anf_ideal_write (ord,*index);
        puts ("");
  
        if (anf_print_level > 2)
        { 
          puts (" With the divisors  :");
          printf (" over (2)           :");anf_ideal_write (ord,*index_2);
          printf (" over (my)          :");anf_ideal_write (ord,*index_my);
          puts ("");
        }
      }
 

      anf_ideal_faclst_delete (ord,&faclst_index);
    }
}