#include "kant.h" 
#include "rel_lattice.h" 
#include "anf_rel_sort.h" 


main()  
/*******************************************************************************
 
AJ Januar 1992
Last modification: -.

 
 
 
Description:
 
	Relative norm equation.
	
        Input format

         1)  Field 1 
         2)  Subfield
         3)  Which routines are called (0= both, 1= rel.., 2= abs....)
         4)  |N()| or N()  (0,1)
         5)  Algebraic integer in the subfield for the relativ norm
         6)  If gammas are read or not (1,0)
         7)  r_1+r_2  Gamma values if in 5) 1 is read
        
        
	 
	Planned: -.

 
Calling sequence:
 
	-
 
History:
 
	92-06-2 AJ    written
 
*******************************************************************************/
{
	block_declarations;         
         
  	int			i,j, n, l, k, nm, m, int1, sj, tj; 
	int			sub_r1, sub_r2, sub_r1r2, subr, read_G;
	t_logical			ok, abs_value;

	char			str[200];

   	t_handle          	R, Z, C;  
	order			ord, sub_ord, rel_ord, ord_h2;   
        anf_elt         	a_elt, a_elt_con, beta_elt, beta_elt_con; 

	t_real			t2_norm, h1, h2, h3, zero, loceps;  
	vector			rel_basis, rel_con;

	anf_rel_sort		sort;

	matrix			mat_h1;

	rel_lattice     	rel_lat;               
        rel_lat_enum_env	rel_env;            
	t_comp			comp_h1, comp, ctemp1, ctemp2, ctemp3, ctemp4, ctemp5;
	int 			lat_flag;

	lattice     	lat;               
        lat_enum_env	env;    

        /*  definitions for the moving of elements  */

	anf_elt			elt_h1, elt_h2, elt_h3, rel_elt, ord_elt, elt_h4, norm_elt;
	matrix			trans_pow_ord, trans_pow_sub_ord;
	matrix			trans_sub_ord_ord, trans_rel_ord;
	matrix			trans_ord_rel;
	matrix			mat_h2, mat_h3, mat_h4, mat_h5;
	integer_big 		det, trans_ord_rel_den, denom, abs_norm, abs_den;
	integer_big 		det_rel, prod_k;
	integer_small		erg, lauf1, lauf2, lauf3, lauf4, flag;
	vector			norms;
	dyn_arr_handle		store1, store2;

        /*  definitions for norm equations  */

	vector			K, G;
        dyn_arr_handle	        sol_list, normal_list;

/*** Initialisation  **********************************************************/

	kant_start();
	printf("\nrelfin.x ...... \n\n");

/*** Input loop  **************************************************************/
 
	while ( order_read(&ord) && order_read(&sub_ord) ) 
	{   
          /*** Initialisation of the orders  ***/
             
		order_reals_set(ord, 20);
		order_reals_create(ord);
		order_mult_table_create(ord); 
		nm=  order_abs_degree(ord);  

                R = order_reals(ord);            
		zero= conv_int_to_real(R,0); 
                loceps= real_make(R, 10, -real_dec_prec(R)+2 );  
		C = comp_create(real_dec_prec(R));
	        Z= m_z_str_incref(structure_z);

		order_reals_set(sub_ord, 20);
		order_reals_create(sub_ord);      

		ord_h2= order_lll_reduce(sub_ord);
                order_delete(&sub_ord); 
	        sub_ord= order_incref(ord_h2);
                order_delete(&ord_h2);        

		order_reals_set(sub_ord, 20);
		order_reals_create(sub_ord);
		order_mult_table_create(sub_ord);
		n=  order_abs_degree(sub_ord);
		sub_r1=  order_r1(sub_ord);
		sub_r2=  order_r2(sub_ord);
		sub_r1r2=  sub_r1+sub_r2;

		if (nm%n)  
		 {
		  printf("\n\nThe second field is not a subfield!\n\n");
		  printf(  "Terminated.\n\n");  

		  goto input_false;
		 }      
                                      
          /*** Construct a relative  basis  ***/

		m= nm/n;
		rel_basis= vec_new(m);  

		elt_h1= order_primitive_elt(ord);
	        for (i=1; i<=m; i++)      
	          vec_entry(rel_basis,i)= anf_power(ord, elt_h1, i-1);
	        anf_elt_delete(ord, &elt_h1);

                if (anf_print_level>=2)
                 {
                  printf("\nRelative Basis in reference to the integral basis:\n");
	          for (i=1; i<=m; i++)      
                   {
	             anf_elt_write(ord, vec_entry(rel_basis,i) );
                     printf("\n");
                   }
                 }
	


          /*** Shortest primitive element   ***/

		beta_elt= order_shortest_primitive_elt(sub_ord);  

                /*** Output of beta_elt           ***/

                beta_elt_con= anf_elt_con(sub_ord, beta_elt);  
               
		if (anf_print_level >=2 )
		 {
		  printf("The conjugates of a shortest primitive");
	  	  printf(" element in the sub_order:\n\n");
                  anf_elt_write(sub_ord,beta_elt); printf("  =  \n");
                  anf_elt_write(sub_ord,beta_elt_con); printf("\n\n");
		 }

                /*** Output of the T_2-norm of beta_elt              ***/

		t2_norm= anf_elt_t2(sub_ord, beta_elt);

		if (anf_print_level >=2 )
		 {
                  printf("T_2-norm of this element:                 "); 		 
                  real_write(R, t2_norm, 20); printf("\n\n\n\n\n\n");
		 }


          /*** Find the representation of beta_elt_con in the integral  ***/
          /*** basis of ord                                             ***/


		if (anf_elt_embed_aj(sub_ord, beta_elt, 0, ord, &a_elt))
 		 {
		  if (anf_print_level >=2 )
		   {
		    printf("Representation of this element in the extention order:\n\n");
		    printf("   ");
                    anf_elt_write(ord,a_elt); printf(" =  ");
                    elt_h1= anf_elt_con(ord, a_elt);
                    anf_elt_write(ord,elt_h1); printf("\n");
		    printf("\nT2-Norm of this element: ");
		    h1= anf_elt_t2(ord, a_elt);
                    real_write(R, h1, 20); 
		    printf("\n\n");
		    real_delete(&h1);                    
		    anf_elt_delete(ord, &elt_h1);
		   }
	   	 }
		else
		 {
		  printf("The second field is not a subfield!\n\n"); 
		  goto  no_sub_order;
		 }




          /*** Find the representation of the powers of the primitiv     ***/
	  /*** element in  sub_ord                                       ***/
                   
         	trans_pow_sub_ord= mat_new(n,n);
	
 		elt_h1= integer_anf_elt_lift(sub_ord, 1);
                anf_elt_to_mat_order_col(sub_ord, elt_h1, trans_pow_sub_ord, 1);
                anf_elt_to_mat_order_col(sub_ord, beta_elt, trans_pow_sub_ord, 2);
		anf_elt_delete(sub_ord, &elt_h1);

        	elt_h1= anf_elt_incref(beta_elt);
	        for (i=3; i<=n; i++)
		 {                  
		  elt_h2= elt_h1;
		  elt_h1= anf_mult(sub_ord, elt_h1, beta_elt);
		  anf_elt_delete(sub_ord, &elt_h2);
                  anf_elt_to_mat_order_col(sub_ord,elt_h1,trans_pow_sub_ord,i);
		 }
		anf_elt_delete(sub_ord, &elt_h1);  

		if (anf_print_level >=3 )
		 {
		  printf("\n\n\n\ntrans_pow_sub_ord= \n");
                  for (i=1; i<=n; i++)
		   {
                    for (j=1; j<=n; j++)
		      printf(" \t %d", mat_elt(trans_pow_sub_ord, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }



          /*** Find the representation of the powers of the primitiv     ***/
	  /*** element of sub_ord in ord                                 ***/
                   
         	trans_pow_ord= mat_new(nm,n);
	
 		elt_h1= integer_anf_elt_lift(ord, 1);
                anf_elt_to_mat_order_col(ord, elt_h1, trans_pow_ord, 1);
                anf_elt_to_mat_order_col(ord, a_elt, trans_pow_ord, 2);
		anf_elt_delete(ord, &elt_h1);

        	elt_h1= anf_elt_incref(a_elt);
                for (i=3; i<=n; i++)
		 {            
		  elt_h2= elt_h1;
		  elt_h1= anf_mult(ord, elt_h1, a_elt);
		  anf_elt_delete(ord, &elt_h2);
                  anf_elt_to_mat_order_col(ord, elt_h1, trans_pow_ord, i);
		 }
		anf_elt_delete(ord, &elt_h1);


		if (anf_print_level >=3 )
		 {
		  printf("\n\ntrans_pow_ord= \n");
                  for (i=1; i<=nm; i++)
		   {
                    for (j=1; j<=n; j++)
		      printf(" \t %d", mat_elt(trans_pow_ord, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }

          /*** Find the representation of the basis of sub_ord in ord    ***/

                mat_h2= mat_z_to_mat_real(R, trans_pow_ord);
                mat_h3= mat_z_to_mat_real(R, trans_pow_sub_ord);
                mat_h4= mat_ring_inverse(R,mat_h3);
		mat_h5= mat_ring_mult(R, mat_h2, mat_h4);  
	        trans_sub_ord_ord= mat_real_to_mat_z(R, mat_h5);

		if (anf_print_level >=3 )
		 {
		  printf("\n\nmat_h5= \n\n");
		  mat_real_write_aj(R, mat_h5, 15);
		  printf("\n \n");
		 }

		if (anf_print_level >=3 )
		 {
		  printf("\n\ntrans_sub_ord_ord= \n");
                  for (i=1; i<=nm; i++)
		   {
                    for (j=1; j<=n; j++)
		      printf(" \t %d", mat_elt(trans_sub_ord_ord, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }

		mat_delref(R, &mat_h2);
		mat_delref(R, &mat_h3);
		mat_delref(R, &mat_h4);
		mat_delref(R, &mat_h5);
		                                    

          /*** Find the representation an relative element in ord       ***/
                                                                   
		trans_rel_ord= mat_new(nm, nm);
                for (i=1; i<=m; i++)
		 { 
                  elt_h1= anf_elt_incref(vec_entry(rel_basis,i));
                  for (j=1; j<=n; j++)
		   { 
		    elt_h3= mat_order_col_to_anf_elt(ord, trans_sub_ord_ord, j);
		    elt_h2= anf_mult(ord, elt_h1, elt_h3);
                    anf_elt_to_mat_order_col(ord, elt_h2, trans_rel_ord, (i-1)*n+j);
	  	    anf_elt_delete(ord, &elt_h2);
	  	    anf_elt_delete(ord, &elt_h3);
		   }
		  anf_elt_delete(ord, &elt_h1);
	         }

		if (anf_print_level >=3 )
		 {
		  printf("\n\ntrans_rel_ord= \n");
                  for (i=1; i<=nm; i++)
		   {
                    for (j=1; j<=nm; j++)
		      printf(" \t %d", mat_elt(trans_rel_ord, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }
		 
		det= mat_z_det(Z, trans_rel_ord);
		det_rel= integer_incref(det);
		if (anf_print_level >=3 )
		 {
		  printf("\nDeterminant: ");
		  integer_write(det);
		  printf("\n \n");
		 }




          /*** Find the of ord in the relative basis if exists       ***/
                                                                   
		mat_h4= mat_z_to_mat_real(R, trans_rel_ord);
		h1=  conv_int_to_real(R, det); 
		h2= real_inverse(R, h1); 
		real_delete(&h1);
		h1= real_abs(R, h2);
		real_delete(&h2);
		mat_h5= mat_ring_scalar_right_mult(R,mat_h4,h1);
		mat_delref(R, &mat_h4);
		real_delete(&h1);
		mat_h4= mat_ring_inverse(R, mat_h5);

		if (anf_print_level >=3 )
        	 {
		  printf("\nmat_h4: \n\n");
		  mat_real_write_aj(R, mat_h4, 20);
		 }

	        trans_ord_rel= mat_real_to_mat_z(R, mat_h4);  
		trans_ord_rel_den= integer_abs(det);
		mat_delref(R, &mat_h4);
		mat_delref(R, &mat_h5);        


		mat_h4= mat_ring_mult(Z, trans_ord_rel, trans_rel_ord);
		if (anf_print_level >=3 )
		 {
		  printf("\n\nInverse test: \n");
                  for (i=1; i<=nm; i++)
		   {
                    for (j=1; j<=nm; j++)
		      printf(" \t %d", mat_elt(mat_h4, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }
		mat_delref(Z, &mat_h4);


		if (anf_print_level >=3 )
		 {
		  printf("\n\ntrans_ord_rel= \n");
                  for (i=1; i<=nm; i++)
		   {
                    for (j=1; j<=nm; j++)
		      printf(" \t %d", mat_elt(trans_ord_rel, i,j) );
	            printf("\n");
	           }
		  printf("\n \n");
		 }

	        integer_delref(det);		 
		det= mat_z_det(Z, trans_rel_ord);
		if (anf_print_level >=3 )
		 {
		  printf("\nDenominator: ");
		  integer_write(trans_ord_rel_den);
		  printf("\n \n");
		 }
        
		
          /*** The order of relative basis multiplied by sub_ord basis  ***/

		rel_ord= order_trans_down(ord, trans_rel_ord);

	        integer_delref(det);		 
	        integer_delref(det_rel);		 
		
		 


          /*** Find the right order of the conjugates of ord over       ***/
          /***  sub_ord                                                 ***/
		 
                a_elt_con= anf_elt_con(ord, a_elt);  

		sort= anf_con_sort_sub(ord, sub_ord, a_elt_con, beta_elt_con); 

		if (anf_print_level >=2 )
		 {
                  printf("\n\n\n\nThe conjugates of this element in the suborder:\n");
                  anf_elt_write(sub_ord,beta_elt_con); printf("\n\n");
                  printf("\nThe conjugates of this element in the extention order:\n");
                  anf_elt_write(ord,a_elt_con); printf("\n\n");
  
                  printf("\nThe right order of the conjugates over the suborder:\n\n");
		  printf("   ");
		  for( j=1; j<= n; j++)   
	           {
		    for( i=1; i<= m; i++) 
		      printf("  %d ", anf_rel_sort_ordering_elt(sort,j,i));
	            printf("     ");
	           }
		  printf("\n");

	 	  printf("\n\n\nF^(j)'s without signature: %d \n", 2*order_r2(sub_ord));
	 	  printf("\n\n\nSignatures over F^(j): \n");
                  for (j= 1;j<= order_r1(sub_ord); j++) 
	  	   {
	 	    sj= anf_rel_sort_real_zeroes_elt(sort,j);
		    tj= anf_rel_sort_comp_zeroes_elt(sort,j);
		    printf("\nF^(%d):  s= %d,  t= %d ", j, sj, tj); 
		   }
                  printf("\n\n");

                  printf("\n\nThe sorted conjugates over the suborder:\n\n");  
		  for( j=1; j<= n; j++) 
	           {
		    for( i=1; i<=m; i++) 
		     {       
                      int1= anf_rel_sort_ordering_elt(sort,j,i);
		      comp_h1= anf_elt_ith_con(ord, a_elt_con, int1 );
		      comp_write_aj(C, comp_h1, 20);
		      printf("\n");
                      comp_elt_delete(C, &comp_h1);
		     }  
	 	    printf("\n");
	           }
		  printf("\n\n");                                             

		 }  /* endif: anf_print_level */

          /*** Computation of the conjugated relativ integral bases     ***/

		rel_con= rel_bases_con(ord, sub_ord, rel_basis, sort);
                
		if (anf_print_level >=2 )
		 {
                  printf("\n\n\nOutput of the conjugated relativ integral bases:\n\n");
		  for( i=1; i<= sub_r1r2; i++) 
		   {
	  	    printf("\n(i= %d):\n", i);
		    mat_comp_write_aj(C, vec_entry(rel_con,i), 20);
		    printf("\n\n");
		   }
		  printf("\n\n");     
		 }

          /*** Computation the solution of the norm equation     ***/


	
                printf ("(nm = %d, s = %d)\n",nm,order_r1(rel_ord));
                printf ("TASK : \n");


                /*** Which subroutine: both (0) or rel_order... (1) or  ***/
                /***                   order_lat... (2)                 ***/ 
                
		scanf("%d", &subr); 
		gets(str);

		if ( (subr<0) || (subr>2) )    
		  error_internal("spri.c: subr has a false value!");



		/* read abs_value */
               
	        scanf("%d", &abs_value);
		gets(str);
                if (abs_value==1)
		  printf("N^(j)( ) will be solve!\n");
                 else
		  printf("|N^(j)( )| will be solve!\n");


		/* read the norms K in form of an algebraic integer of sub_ord */
                          
		K= vec_new(sub_r1r2);

		norm_elt= anf_elt_read(sub_ord);
		printf("relative norm: ");
	        anf_elt_write(sub_ord, norm_elt);                  
	        printf("\n"); 
	  
		printf("absolute conjugated relative norms:  ");
      	        for (i=1;i<=sub_r1r2;i++) 
 	         {
                  comp_h1= anf_elt_ith_con(sub_ord, norm_elt, i);
 	          h1= comp_norm(C, comp_h1);
	          vec_entry(K,i)= real_sqrt(R, h1);
	          real_write_aj(R, vec_entry(K,i), 15);
                  comp_elt_delete(C, &comp_h1);
                  real_delete(&h1);
	         }          
		printf("\n");


	        h1= conv_int_to_real(R, 1);
     	        for (i=1;i<=sub_r1;i++) 
     	         {                                                            
	          h2= h1;
		  h1= real_mult(R,h2,vec_entry(K,i));
	          real_delete(&h2);
     	         }                         
     	        for (i=sub_r1+1;i<=sub_r1r2;i++) 
     	         {                                                            
	          h2= h1;
	          h3= real_power(R, vec_entry(K,i), 2);
		  h1= real_mult(R,h2, h3);
	          real_delete(&h2);
	          real_delete(&h3);
     	         }                         

		prod_k= conv_real_to_int_round(R, h1);
		printf("absolute norm: %d \n", prod_k);

	        real_delete(&h1);



		/* read the Gammas G */
              
		scanf("%d", &read_G); 
		gets(str);

                if(read_G)
		 {
                  G= vec_new(sub_r1r2);
	   	  printf("gamma's: ");
                  for (i=1; i<= sub_r1r2; i++)
		   {
	            scanf("%d", &int1);
		    gets(str); 
		    vec_entry(G,i)= conv_int_to_real(R, int1);
	            printf("  %d  ", int1);
		   }                   
	          printf("\n");                
                 }
                else
                 {
                  rel_order_fincke_find_gamma_opt(sub_ord, K, &G, sort);           
                
                  printf("\nOptimale gamma's: \n\n");
                  mat_real_write_aj(R, G, 10);
	          printf("\n \n");
                 }



		if (subr>1)  goto label_order_lat;

                       

		printf("\nSolution of a relative norm equation:\n\n");

                ok= rel_order_lat_norm_equation_mod(ord, sub_ord, rel_ord, rel_con, K, G, sort,
        		                        &sol_list, TRUE, norm_elt, abs_value);
                

		if (ok)
	         {
	          if (anf_print_level >= 1)
	           {    
		    printf("\nSolutions found: \n\n");
		    for (l=1; l<= dyn_arr_curr_length(sol_list); l++ )
		     {
     	              for (i=1;i<=m;i++) 
     	               {
     	                anf_elt_write(sub_ord, vec_entry(dyn_arr_element(sol_list,l-1),i) );
	                if (i<m) printf(" ,      "); 
     	               }
                      printf("\n");

	              anf_elt_alloc(rel_elt, nm);
	              anf_elt_den(rel_elt) = 1;
	              for(i=1;i<=m;i++) 
	               {
	                for (j=1; j<=n; j++)
	                {	
		          anf_elt_coef(rel_elt,(i-1)*n+j)= 
                           integer_incref(anf_elt_coef(vec_entry(dyn_arr_element(sol_list,l-1),i),j));
	                }
	               }

	              norms= anf_elt_rel_norms(rel_ord, sub_ord, rel_elt, sort, abs_value); 

	              if (abs_value==FALSE)
	                {
	 	         printf("norm:   ");
	                 h1= conv_int_to_real(R, 1);
     	                 for (j=1;j<=sub_r1;j++) 
     	                  {                                                            
	                   h2= h1;
		           h1= real_mult(R,h2,vec_entry(norms,j));
	                   real_delete(&h2);
     	 	           real_write_aj(R, vec_entry(norms,j), 15);
		           if (j!=sub_r1r2)  printf(" * ");
     	                  }                         
	                 for (j=sub_r1+1;j<=sub_r1r2;j++) 
     	                  {                                                            
	                   h2= h1;  
	                   h3= real_power(R, vec_entry(norms,j), 2);
		           h1= real_mult(R,h2,h3);
	                   real_delete(&h2);
	                   real_delete(&h3);
     		           real_write_aj(R, vec_entry(norms,j), 15);
		           printf("^2");
		           if (j!=sub_r1r2)  printf("  * ");
     	                  }                          

     	                 printf(" =  "); 
      	                 real_write_aj(R, h1, 15);
	                 elt_h1= anf_elt_con(rel_ord, rel_elt);
	                 anf_norm(rel_ord, elt_h1, &abs_norm, &abs_den);
	                 anf_elt_delete(rel_ord, &elt_h1);
	                 printf("   (absolute= ");
	                 integer_write(abs_norm);
	                 printf(")\n\n");
                         integer_delref(abs_norm);
                         integer_delref(abs_den);
	                 real_delete(&h1);   
             
        	         vec_delete(R, &norms);
                        }
	               else
                        {
	                 printf("norm:   ");
	                 ctemp1= conv_int_to_comp(C, 1);
     	                 for (j=1;j<=sub_r1;j++) 
     	                  {                                                            
	                   ctemp2= ctemp1;
	        	   ctemp1= comp_mult(C,ctemp2,vec_entry(norms,j));
	                   comp_elt_delete(C, &ctemp2);
     	         	   comp_write_aj(C, vec_entry(norms,j), 15);
	        	   if (j!=sub_r1r2)  printf("\n * ");
     	                  }                         
	                 for (j=sub_r1+1;j<=sub_r1r2;j++) 
     	                  {                                                            
	                   ctemp2= ctemp1;  
	                   ctemp3= comp_incref(vec_entry(norms,j));
	        	   ctemp4= comp_conjugate(C, ctemp3);
	        	   printf("(");
     	        	   comp_write_aj(C, ctemp3, 15);
	                   printf(" * ");
     	        	   comp_write_aj(C, ctemp4, 15);
	        	   printf(")");
	        	   ctemp5= comp_mult(C, ctemp3, ctemp4);
	        	   ctemp1= comp_mult(C,ctemp2,ctemp5);
	                   comp_elt_delete(C, &ctemp2);
	                   comp_elt_delete(C, &ctemp3);
	                   comp_elt_delete(C, &ctemp4);
	                   comp_elt_delete(C, &ctemp5);
	        	   if (j!=sub_r1r2)  printf("\n  * ");
     	                  }                          

     	                 printf(" =  "); 
      	                 comp_write_aj(C, ctemp1, 15);
	                 elt_h1= anf_elt_con(rel_ord, rel_elt);
	                 anf_norm(rel_ord, elt_h1, &abs_norm, &abs_den);
	                 anf_elt_delete(rel_ord, &elt_h1);
	                 printf("   (absolute= ");
	                 integer_write(abs_norm);
	                 printf(")\n\n");
                         integer_delref(abs_norm);
                         integer_delref(abs_den);
	                 comp_elt_delete(C, &ctemp1);   

	                 vec_delete(C, &norms);  
	                }
                       
		       anf_elt_delete(rel_ord, &rel_elt);

	             }                      
	           }
                 }
		else
		  if (anf_print_level >= 1) printf("\nNo solution found! \n");


		for (i=1; i<=dyn_arr_curr_length(sol_list); i++)
		 {
		  for (j=1; j<=m; j++)
		   {
		    anf_elt_delete(sub_ord, &vec_entry(dyn_arr_element(sol_list,i-1),j));
		    vec_entry(dyn_arr_element(sol_list,i-1),j)= 0;
	           }
		  vec_delete(Z, &dyn_arr_element(sol_list,i-1));   
                
		  dyn_arr_element(sol_list,i-1)= 0;
	         }
		dyn_arr_delete(&sol_list);   


          /*** Normal norm equation  ***/ 
                                                   
		if (subr==1)  goto deleting_storage;

label_order_lat:

		printf("\nSolution of the norm equation by Fincke:\n\n");
	     	order_norm_equation_aj(rel_ord, sub_ord,prod_k, &elt_h1, 
                                       &normal_list, TRUE,abs_value,sort, K, norm_elt);

		if ((normal_list != MEM_NH)&&(anf_print_level>=1))
		 {
		  printf ("\nSolutions of normal norm equation : \n\n");
		  for (l=1;l<=dyn_arr_curr_length (normal_list);l++)  
		   {                     
		    anf_elt_write (rel_ord,dyn_arr_element (normal_list,l-1));		
		    printf("\n");                          
		    rel_elt= dyn_arr_element (normal_list,l-1);
	            norms= anf_elt_rel_norms(rel_ord, sub_ord, 
			     rel_elt, sort, abs_value); 
                      

 	            if (abs_value==FALSE)
	              {
	 	       printf("norm:   ");
	               h1= conv_int_to_real(R, 1);
     	               for (j=1;j<=sub_r1;j++) 
     	                {                                                            
	                 h2= h1;
		         h1= real_mult(R,h2,vec_entry(norms,j));
	                 real_delete(&h2);
     	 	         real_write_aj(R, vec_entry(norms,j), 15);
		         if (j!=sub_r1r2)  printf("     * ");
     	                }                         
	               for (j=sub_r1+1;j<=sub_r1r2;j++) 
     	                {                                                            
	                 h2= h1;  
	                 h3= real_power(R, vec_entry(norms,j), 2);
		         h1= real_mult(R,h2,h3);
	                 real_delete(&h2);
	                 real_delete(&h3);
     		         real_write_aj(R, vec_entry(norms,j), 15);
		         printf("^2");
		         if (j!=sub_r1r2)  printf("      * ");
     	                }                          

     	               printf(" =  "); 
      	               real_write_aj(R, h1, 15);
	               elt_h1= anf_elt_con(rel_ord, rel_elt);
	               anf_norm(rel_ord, elt_h1, &abs_norm, &abs_den);
	               anf_elt_delete(rel_ord, &elt_h1);
	               printf("   (absolute= ");
	               integer_write(abs_norm);
	               printf(")\n\n");
                       integer_delref(abs_norm);
                       integer_delref(abs_den);
	               real_delete(&h1);   
                       
        	       vec_delete(R, &norms);
                      }
	             else
                      {
	               printf("norm:   ");
	               ctemp1= conv_int_to_comp(C, 1);
     	               for (j=1;j<=sub_r1;j++) 
     	                {                                                            
	                 ctemp2= ctemp1;
	                 ctemp1= comp_mult(C,ctemp2,vec_entry(norms,j));
	                 comp_elt_delete(C, &ctemp2);
     	                 comp_write_aj(C, vec_entry(norms,j), 15);
	                 if (j!=sub_r1r2)  printf("\n * ");
     	                }                         
	               for (j=sub_r1+1;j<=sub_r1r2;j++) 
     	                {                                                            
	                 ctemp2= ctemp1;  
	                 ctemp3= comp_incref(vec_entry(norms,j));
	                 ctemp4= comp_conjugate(C, ctemp3);
	                 printf("(");
     	                 comp_write_aj(C, ctemp3, 15);
	                 printf(" * ");
     	                 comp_write_aj(C, ctemp4, 15);
	                 printf(")");
	                 ctemp5= comp_mult(C, ctemp3, ctemp4);
	                 ctemp1= comp_mult(C,ctemp2,ctemp5);
	                 comp_elt_delete(C, &ctemp2);
	                 comp_elt_delete(C, &ctemp3);
	                 comp_elt_delete(C, &ctemp4);
	                 comp_elt_delete(C, &ctemp5);
	                 if (j!=sub_r1r2)  printf("\n  * ");
     	                }                          

     	               printf(" =  "); 
      	               comp_write_aj(C, ctemp1, 15);
	               elt_h1= anf_elt_con(rel_ord, rel_elt);
	               anf_norm(rel_ord, elt_h1, &abs_norm, &abs_den);
	               anf_elt_delete(rel_ord, &elt_h1);
	               printf("   (absolute= ");
	               integer_write(abs_norm);
	               printf(")\n\n");
                       integer_delref(abs_norm);
                       integer_delref(abs_den);
	               comp_elt_delete(C, &ctemp1);   

	               vec_delete(C, &norms);
	              }

		   }

		  for (i=1; i<=dyn_arr_curr_length(normal_list); i++)
		   {
		    anf_elt_delete(rel_ord, &dyn_arr_element(normal_list,i-1) );
		    dyn_arr_element(normal_list,i-1)= 0;
	           }
		  dyn_arr_delete(&normal_list);   
		 }
		else
		  if (anf_print_level>=1) puts ("NO SOLUTION");
	  	printf("\n \n");

	  	if (elt_h1!=MEM_NH)  anf_elt_delete(rel_ord, &elt_h1);
	
		integer_delref(prod_k);




          /*** End of while loop: delete storage  ***/     

deleting_storage:
	
	        anf_elt_delete(sub_ord, &norm_elt);

		anf_rel_sort_delete(&sort); 

		for (i=1; i<=sub_r1r2; i++)
		 {
		  real_delete(&vec_entry(K,i));
		  vec_entry(K,i)= 0;
	         }
		vec_delete(Z, &K);   

		for (i=1; i<=sub_r1r2; i++)
		 {
		  real_delete(&vec_entry(G,i));
		  vec_entry(G,i)= 0;
	         }
		vec_delete(Z, &G);   


		for (i=1; i<=m; i++)
		 {
		  anf_elt_delete(ord, &vec_entry(rel_basis,i));
		  vec_entry(rel_basis,i)= 0;
	         }
		vec_delete(Z, &rel_basis);   

		for (i=1; i<=sub_r1r2; i++)
		 {
		  mat_delref(C, &vec_entry(rel_con,i));
		  vec_entry(rel_con,i)= 0;
		 }
		vec_delete(Z, &rel_con);      


no_sub_order:	anf_elt_delete (ord,&a_elt);
		anf_elt_delete (ord,&a_elt_con);  

		anf_elt_delete (sub_ord,&beta_elt);	 
		anf_elt_delete (sub_ord,&beta_elt_con); 
 
		real_delete(&t2_norm);  


		mat_delref(Z, &trans_pow_ord);
		mat_delref(Z, &trans_pow_sub_ord);
		mat_delref(Z, &trans_sub_ord_ord);
		mat_delref(Z, &trans_rel_ord);
		mat_delref(Z, &trans_ord_rel);
		integer_delref(trans_ord_rel_den);

                        


input_false:	real_delete(&zero);
		real_delete(&loceps);
		order_delete(&ord);
 		order_delete(&sub_ord); 
 		order_delete(&rel_ord); 

		ring_delete(&C);
		ring_delete(&Z);
                          
	} 

/*** End  *********************************************************************/
 

}         

