#include "kant.h"
#include "thue.h" 

t_real
thue_baker_init_delta2 WITH_5_ARGS(
                thue,                	th,
                integer_small,          j,
                integer_small,          k,
                integer_small,          l,
                t_real,                 log_delta_r
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	integer_small	deg,r,u;
	t_real		h1, h2, h3, h4, h5, h6, h7, h8;
        t_comp          con1, con2; 
        order           ord;
        anf             field;
        vector          delta;
	t_handle	R;
     
        deg = thue_abs_degree(th);
        ord = thue_order(th);
	R = order_reals(ord);
        r = order_r(ord);
        field = order_anf(ord);

        h1 = anf_poly_z_zero(field, 1, j);
        h2 = anf_poly_z_zero(field, 1, k);
        h3 = anf_poly_z_zero(field, 1, l);
        h4 = real_subtract(R, h2, h3);
        h5 = real_subtract(R, h1, h3);
        h8 = real_divide(R, h4, h5);    
        real_delete(&h4);
        real_delete(&h5);
        h4 = real_abs(R, h8);
        real_delete(&h8);
        h5 = real_log(R, h4);
        real_delete(&h4);
        h6 = real_divide(R, h5, log_delta_r);
        real_delete(&h5);
        
        return h6;
}


