#include "kant.h"
#include "thue.h" 

t_real
thue_bd_B1 WITH_10_ARGS(
                thue,           th,
		t_handle,	R,
                t_real,		Q1,
                t_real,         Q2,
                t_real,         Q3,
                t_real,         c4,
                t_real,         c5,
                t_real,         log_delta_r,
                t_real,         q_max,
                t_real,         dist_min
)

/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	t_int		r;
	t_real		h1, h2, h3, h4, c8, dum, Q1_min;
        order           ord;
        
        ord = thue_order(th);
        r = order_r(ord);

        Q1_min = thue_bd_Q1_min(th, R, Q1, Q2, Q3, q_max, dist_min);
        if (thue_print_level(th) >= 4 )
                {
                printf("Q1_min = ");real_write(R, Q1_min, 20); puts("");
                }
        c8 = thue_bd_c8(th, R, c5, log_delta_r);
        h1 = conv_int_to_real(R, r);
        h2 = conv_int_to_real(R, r-1);
        h3 = real_divide(R, h1, h2);
        real_delete(&h1);
        real_delete(&h2);
        h1 = real_real_power(R, Q3, h3);
        real_delete(&h3);
        h2 = real_mult(R, h1, Q1_min);
        real_delete(&h1);
        real_delete(&Q1_min);
        h4 = real_mult(R, h2, c8);
        real_delete(&h2);
        h1 = real_log(R, h4);
        real_delete(&h4);
        h2 = real_divide(R, h1, c4);
        real_delete(&h1);
        real_delete(&c8);

        return h2;
}


