#include "kant.h"
#include "thue.h" 

void
thue_big_solutions WITH_3_ARGS(
                thue,           th,
                t_real,         alpha,
                t_real,         y_max
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	t_int		deg;
        t_int           pn2, pn1, pn, qn2, qn1, qn, mpn, mqn, a0, an, n;
        t_int           x, y;
	t_handle	R;
	t_real		theta, theta1, test, h1, h2, zero, one;
        order           ord;

        ord = thue_order(th);
        deg = thue_abs_degree(th);
        R = thue_reals(th);
                    
        pn2 = 1;
        qn2 = 0;
	thue_test_solution_pos(th, 1, 0);
	thue_test_solution_pos(th, -1, 0);
        thue_test_solution_neg(th, 1, 0);
        thue_test_solution_neg(th, -1, 0);

        qn1 = 1;
	h1 = real_int(R, alpha);
	one = conv_int_to_real(R, 1);
	zero = conv_int_to_real(R, 0);
	if (real_compare(R, alpha, zero) == -1)
		{
		h2 = real_subtract(R, h1, one);
		real_delete(&h1);
		h1 = real_subtract(R, alpha, h2);
		theta = real_inverse(R, h1);
		real_delete(&h1);
		pn1 = conv_real_to_int_round(R, h2);
		real_delete(&h2);
		}
	else
		{
		pn1 = conv_real_to_int_round(R, h1);
		h2 = real_frac(R, alpha);
		theta = real_inverse(R, h2);
		real_delete(&h2);
		}
	real_delete(&zero);
	real_delete(&one);
	thue_test_solution_pos(th, pn1, qn1);
	thue_test_solution_neg(th, pn1, qn1);
	mpn=integer_negate(pn1);
	mqn=integer_negate(qn1);
	thue_test_solution_pos(th, mpn, mqn);        
	thue_test_solution_neg(th, mpn, mqn);
	integer_delete(&mpn);
	integer_delete(&mqn);

	for(n=2;;n++)
                { 
       		theta1 = thue_frac_step(R, pn2,qn2,pn1,qn1, theta, &pn, &qn);
                test = conv_int_to_real(R, qn);
                h1 = test;
		test = real_abs(R, h1);
                real_delete(&h1);
                thue_test_solution_pos(th, pn, qn);
                thue_test_solution_neg(th, pn, qn);
		mpn=integer_negate(pn);
		mqn=integer_negate(qn);
		thue_test_solution_pos(th, mpn, mqn);
		thue_test_solution_neg(th, mpn, mqn);
		integer_delete(&mpn);
		integer_delete(&mqn);
                if (real_compare(R, test, y_max) == 1)
                        break;
                real_delete(&test);
                integer_delete(&pn2);
                integer_delete(&qn2);
                pn2 = pn1;
                qn2 = qn1;
                pn1 = pn;
                qn1 = qn;
                real_delete(&theta);
                theta = theta1;
                } 
        integer_delete(&pn2);
        integer_delete(&qn2);
        integer_delete(&pn1);
        integer_delete(&qn1);
        integer_delete(&pn);
        integer_delete(&qn);
        real_delete(&theta);
        real_delete(&theta1);
        real_delete(&test);

}
