#include "kant.h"
#include "thue.h" 

void
thue_small_solutions WITH_2_ARGS(
                thue,           th,
                t_real,         y_max
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	t_int		deg, y, i, r1, x, y0, h1, M, x_neg, y_neg;
        t_real          x_real, dist, eps;
	t_handle	Z,R;
        order           ord;
        vector          yy, zeroes;
        t_poly          pol, pol1;

        ord = thue_order(th);
        deg = thue_abs_degree(th);
        R = thue_reals(th);
	Z = m_z_str_incref(structure_z);

        y0 = conv_real_to_int_ceil(R, y_max);
        M = thue_M(th);
        for (y=-y0; y<=y0; y++)
                {
        	yy = vec_new(deg+1);
       	        m_poly_u_create_empty(&pol1, deg+1);
       	        vec_entry(yy, 1) = 1;
                for (i=2;i<=deg+1;i++)
                        vec_entry(yy, i)= integer_mult(vec_entry(yy, i-1), y);
		for (i=1;i<=deg+1;i++)
                       	{
                       	m_poly_coefft(pol1,deg+1-i) = integer_mult(vec_entry(yy, i), thue_coeff(th, deg+2-i));
                       	m_poly_expt(pol1,deg+1-i) = deg+1-i;
                       	}
                vec_delete(Z, &yy);
                h1 = m_poly_coefft(pol1, 0);
                m_poly_coefft(pol1, 0) = integer_subtract(h1, M);
                integer_delete(&h1);
		pol = poly_z_clean(structure_pring_z, m_poly_handle_to_poly(pol1));
	        m_poly_z_delref(structure_pring_z, pol1);
		zeroes = thue_poly_zeroes(R, pol, deg, &r1);
	        m_poly_z_delref(structure_pring_z, pol); 
                eps = conv_double_to_real(R, 0.001);
                for (i=1;i<=r1;i++)
                       	{
                       	x_real = vec_entry(zeroes, i);
                       	dist = real_to_next_int(R, x_real);
                       	if (real_compare(R, dist, eps) == -1)
                               	{
                               	x = conv_real_to_int_round(R, x_real);
                               	thue_test_solution_pos(th, x, y);
                                if (deg % 2 == 1)
                                	{
                                        x_neg = integer_negate(x);
                                        y_neg = integer_negate(y);
                                        thue_test_solution_neg(th, x_neg, y_neg);
                                        integer_delete(&x_neg);
                                        integer_delete(&y_neg);
                                        }
                               	integer_delete(&x);
                               	} 
                       	real_delete(&dist);
                       	}
               	real_delete(&eps);
               	integer_delete(&r1);
               	vec_delete(R, &zeroes);
      		}
      	integer_delete(&y0);

        if (deg % 2 == 0)
                {
        	y0 = conv_real_to_int_ceil(R, y_max);
        	M = integer_negate(thue_M(th) );
        	for (y=-y0; y<=y0; y++)
                	{
        	        yy = vec_new(deg+1);
       	         	m_poly_u_create_empty(&pol1, deg+1);
       	         	vec_entry(yy, 1) = 1;
                	for (i=2;i<=deg+1;i++)
                        vec_entry(yy, i)= integer_mult(vec_entry(yy, i-1), y);
			for (i=1;i<=deg+1;i++)
                        	{
                        	m_poly_coefft(pol1,deg+1-i) = integer_mult(vec_entry(yy, i), thue_coeff(th, deg+2-i));
                        	m_poly_expt(pol1,deg+1-i) = deg+1-i;
                        	}
                	vec_delete(Z, &yy);
                        h1 = m_poly_coefft(pol1, 0);
                        m_poly_coefft(pol1, 0) = integer_subtract(h1, M);
                        integer_delete(&h1);
			pol = poly_z_clean(structure_pring_z, m_poly_handle_to_poly(pol1));
	        	m_poly_z_delref(structure_pring_z, pol1);
			zeroes = thue_poly_zeroes(R, pol, deg, &r1);
	        	m_poly_z_delref(structure_pring_z, pol); 
                
                	eps = conv_double_to_real(R, 0.001);
                	for (i=1;i<=r1;i++)
                        	{
                        	x_real = vec_entry(zeroes, i);
                        	dist = real_to_next_int(R, x_real);
                        	if (real_compare(R, dist, eps) == -1)
                                	{
                                	x = conv_real_to_int_round(R, x_real);
                                	thue_test_solution_neg(th, x, y);
                                	integer_delete(&x);
                                	} 
                        	real_delete(&dist);
                        	}
                	real_delete(&eps);
                	integer_delete(&r1);
                	vec_delete(R, &zeroes);
               		}
       		integer_delete(&y0);
        	integer_delete(&M);
                }
}
