#include "kant.h"
#include "thue.h" 

void
thue_test_solution_neg WITH_3_ARGS(
                thue,           th,
                t_int,          x,
                t_int,          y
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	t_int		deg, i, h1, h2, h3, h4, f, M;
	t_handle	Z;
        order           ord;
        vector          xx, yy;
        t_logical       L;

        ord = thue_order(th);
        deg = thue_abs_degree(th);
	Z = m_z_str_incref(structure_z);

        xx = vec_new(deg+1);
        yy = vec_new(deg+1);
        vec_entry(xx,1) = 1;
        vec_entry(yy,1) = 1;
        f = 0;
        M = integer_negate(thue_M(th) );

        for (i=2;i<=deg+1;i++)
                {
                vec_entry(xx,i) = integer_mult(vec_entry(xx, i-1), x);
                vec_entry(yy,i) = integer_mult(vec_entry(yy, i-1), y);
                }
        for (i=1;i<=deg+1;i++)
                {
                h1 = thue_coeff(th, deg+2-i);
                h2 = integer_mult(h1, vec_entry(xx, deg+2-i) );
                h3 = integer_mult(h2, vec_entry(yy, i) );
                integer_delete(&h2);
                h4 = integer_add(h3, f);
                integer_delete(&f);
                f = h4;
                integer_delete(&h3);
                }

        if ( integer_compare(f ,M) == 0 ) 
                {
                thue_solution_save_neg(th, x, y);
                }
        vec_delete(Z, &xx);
        vec_delete(Z, &yy);
	integer_delete(&f);  
        integer_delete(&M);
        return;
}





