#include "kant.h"
#include "thue.h" 

t_real
thue_waldschmidt_c3 WITH_2_ARGS(
                thue,           th,
                t_real,         c1
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	integer_small	r, deg;
	t_handle	R;
        integer_big     hh1;
	t_real		h1, h2, h3, h4, M, c3;
        order           ord;
        
        deg = thue_abs_degree(th);
        ord = thue_order(th);
        R = thue_reals(th);
        r = order_r(ord);

        h1 = conv_int_to_real(R, thue_M(th) );
        h2 = conv_int_to_real(R, thue_coeff(th, 1) );
        M = real_divide(R, h1, h2);
        real_delete(&h1);
        real_delete(&h2);

        hh1 = integer_mult(deg, r);
        h1 = conv_int_to_real(R, hh1);
        integer_delete(&hh1);
        h2 = real_mult(R, h1, c1);
        real_delete(&h1);
        h1 = conv_int_to_real(R, 4);
        h3 = real_abs(R, M);
        real_delete(&M);
        h4 = real_log(R,h3);
        real_delete(&h3);
        h3 = real_mult(R, h4, h1);
        real_delete(&h4);
        real_delete(&h1);
        h1 = real_add(R, h2, h3);
        real_delete(&h2);
        real_delete(&h3);
        hh1 = integer_mult(2, deg-1 );
        h2 = conv_int_to_real(R, hh1);
        integer_delete(&hh1);
        c3 = real_divide(R, h1, h2);
        real_delete(&h1);
        real_delete(&h2);

        return c3;
}
