#include "kant.h"
#include "thue.h" 

t_real
thue_waldschmidt_c7 WITH_6_ARGS(
                thue,           th,
                vector,         v,
                t_real,         e,
                t_real,         Ck,
                t_real,         D,
                t_real,         vk1pl
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	integer_small	i, r, deg;
	t_handle	R;
	t_real		h1, h2, h3, c7;
        order           ord;

        ord = thue_order(th);
        R = thue_reals(th);
        r = order_r(ord);
	deg = thue_abs_degree(th);

        h2 = real_power(R, D, deg+2);
        h1 = real_mult(R, Ck, h2);
        real_delete(&h2);
        for (i=1; i<=deg; i++)  
                {
                h3 = h1;
                h1 = real_mult(R, h1, vec_entry(v, i));
                real_delete(&h3);
                }
        h2 = real_mult(R, e, D);
        h3 = real_mult(R, h2, vk1pl);
        real_delete(&h2);
        h2 = real_log(R, h3);
        real_delete(&h3);
        c7 = real_mult(R, h2, h1);
        real_delete(&h1);
        real_delete(&h2);
        
        return c7;
}
