#include "kant.h"
#include "thue.h" 

void
thue_waldschmidt_init_a0 WITH_5_ARGS(
                thue,           th,
                integer_small,  j,
                integer_small,  k,
                integer_small,  l,
                anf_elt,        gamma
)
/*******************************************************************************

Description: 

Calling sequence: 
	
History:

*******************************************************************************/
{
	block_declarations;
 
	integer_small	deg,r,u;
	t_handle	R;
	t_real		h1, h2, h3, h33, h4, h5, h6, h7, h8, h9;
        t_comp          con1, con2; 
        order           ord;
        anf             field;
        vector          delta;

        deg = thue_abs_degree(th);
        ord = thue_order(th);
        R = thue_reals(th);
        r = order_r(ord);
        field = order_anf(ord); 

        h1 = anf_poly_z_zero(field, 1, j);
        h2 = anf_poly_z_zero(field, 1, l);
        h4 = real_subtract(R, h1, h2);
        h6 = thue_waldschmidt_a0(th);
        h7 = real_mult(R, h6, h4);
        thue_waldschmidt_a0(th) = real_abs(R, h7);
	real_delete(&h4);
	real_delete(&h6);
        real_delete(&h7);
}

