#include "kant.h"
#include "thue.h" 

t_comp
thue_zero WITH_2_ARGS(
                thue,           th,
                t_int,          i
)
/*******************************************************************************

Description: 

Calling sequence: 
        
History:

*******************************************************************************/
{
        block_declarations;
 
        t_int		deg, r, r1, r2;
        t_handle        R, C;
        t_real          h1, h2;
	t_comp		z;
        order           ord;
        anf             field;

        deg = thue_abs_degree(th);
        ord = thue_order(th);
        R = order_reals(ord);
        C = comp_create(real_dec_prec(R));
        r = order_r(ord);
        field = order_anf(ord);
	r1 = order_r1(ord);
	r2 = order_r2(ord);

	if (i <= r1)
		{
		h1 = real_incref(anf_poly_z_zero(field, 1, i));
		h2 = conv_int_to_real(R, 0);
		}
	if ((i > r1) && (i <= r1+r2))
		{
		h1 = real_incref(anf_poly_z_zero(field, 1, i));
		h2 = real_incref(anf_poly_z_zero(field, 1, i+r2));
		}
	if (i > r1+r2)
		{
		h1 = real_incref(anf_poly_z_zero(field, 1, i-r2));
		h2 = real_negate(R, anf_poly_z_zero(field, 1, i));
		}
	z = comp_make(C, h1, h2);
	real_delete(&h1);
	real_delete(&h2);
	ring_delete(&C);

	return z;
} 
