      SUBROUTINE COMIN0()
C
C     ***************************************************************
C     *                                                             *
C     *                    S U B R O U T I N E                      *
C     *                                                             *
C     *                        C O M I N 0                          *
C     *                                                             *
C     ***************************************************************
C
*DOC             Erasing of field data
**DOC
*INDEX  COMIN0(FI/1): Erasing of Field Data
**DOC
**DOC   (1) DESCRIPTION IN DETAIL:
**DOC       This routine sets the field parameters to zero or "blank":
**DOC           EXFLAG(I)  <--  0   for I=1,..,9
**DOC           EXFLAG(10) <-- -1 
**DOC           N          <--  0
**DOC           GALGRP     <--  0
**DOC           FLDFLG     <--  0
**DOC       
**DOC       This routine must be called by routines like COMINP or FLDRD first.
**DOC
**DOC   (2) PARAMETER (IN):
**DOC       -
**DOC
**DOC   (3) PARAMETER (OUT):
**DOC       -
**DOC
**DOC   (4) PARAMETER (IN/OUT):
**DOC       -
**DOC
**DOC   (5) MODIFICATIONS OF GLOBAL VARIABLES:
**DOC       see (1)
**DOC
**DOC   (6) SUBROUTINES CALLED:
**DOC       -
**DOC
**DOC   (7) INCLUDE-FILES USED:
**DOC       FIELD
**DOC
**DOC   (8) AUTHOR(S):
**DOC       JS       23.02.90  
**DOC
**DOC   (9) MODIFICATIONS:
**DOC       JS       10.04.90  FLDNR
**DOC       JS       26.04.90  EXFLAG(10) <-- -1
**DOC       JS       27.04.90  Setting back NS, NR, NT
**DOC       JS       30.10.90  No reset of FLDNR anymore
**DOC
%include 'field.inc'
*
      INTEGER I
*
*  field degree N
*
      N  = 0
      NS = -1
      NR = -1
      NT = -1
*
*  EXFLAGs (i.e. integral basis, units etc.)
*
      DO 100 I=1,9
100        EXFLAG(I) = 0
*
*  number of real zeroes not known
*
      EXFLAG(10) = -1           
*
      GALGRP = '      '
      FLDFLG = 0
*
*  exit
*
      RETURN
      END
