      SUBROUTINE FLDRD(FNR,FILENA,*)
*
C     ******************************************************************
C     *                                                                *
C     *                    S U B R O U T I N E                         *
C     *                                                                *
C     *                         F L D R D                              *
C     *                                                                *
C     ******************************************************************
*
*DOC         Field Input with direct access
**DOC
*INDEX  FLDRD (IN/1): Field Input 
**DOC
**DOC   (1) DESCRIPTION IN DETAIL:
**DOC       All common variables are restored from the file named FILENA with
**DOC       direct access. If FILENA='SCRATCH' the file is supposed to
**DOC       be a scratch file. In this case FNR is used as file number.
**DOC
**DOC   (2) PARAMETER (IN):
**DOC       FILENA(STR)     : filename
**DOC       FNR             : device number for scratch mode
**DOC
**DOC   (3) PARAMETER (OUT):
**DOC       -
**DOC
**DOC   (4) PARAMETER (IN/OUT):
**DOC       -
**DOC
**DOC   (5) MODIFICATIONS OF GLOBAL VARIABLES:
**DOC       -
**DOC
**DOC   (6) SUBROUTINES CALLED:
**DOC       START       END 
**DOC       FLNGET      FLKILL
**DOC       IERDEL      COMIN0
**DOC
**DOC   (7) INCLUDE-FILES USED:
**DOC       FIELD     
**DOC       LARITH
**DOC       LFIELD
**DOC       
**DOC
**DOC   (8) AUTHOR(S):
**DOC       MJ        13.02.90
**DOC
**DOC   (9) MODIFICATIONS:
**DOC       JS       22.02.90  COMIN0
*
%include 'field.inc'
%include 'larith.inc'
%include 'lfield.inc'
      INTEGER I,J,K,L,M,FNR,LFMAX,FLAG
      CHARACTER*(*) FILENA 
*
*
      CALL START('FLDRD ')
*
      CALL COMIN0()
*      
      IF ( INDEX(FILENA,'SCRATCH') .NE. 0 ) THEN 
          FLAG = 0
      ELSE
         FLAG = 1
         CALL FLNGET(FNR,*9999)
         K = MAXDIM*MAXDIM*MAXDIM*4
         OPEN(FNR,FILE=FILENA,ACCESS='DIRECT',RECL=K) 
      ENDIF
      READ(FNR,REC=1)N,NS,NT,NR,NST,NP1,NM1,NSP1,
     *                 CDEN,NP2,DISC,RDISC,LDISC(1),REG,
     *                 (EXFLAG(I),I=1,10),(F(I),I=1,N),
     *                 (ROOTSF(I),I=1,N),
     *                 ((CROOTS(I,J),J=1,N),I=1,2),                 
     *                 ((ITB(I,J),I=1,NP1),J=1,N),
     *                 ((INVITB(I,J),I=1,N),J=1,N),
     *                 ((REDRHO(I,J),I=1,N),J=1,N),
     *                 ((RITB(I,J),I=1,N),J=1,N),
     *                 ((RITBER(I,J),I=1,N),J=1,N),
     *                 ((DUALB(I,J),I=1,N),J=1,N),
     *                 ((ABSDUA(I,J),I=1,N),J=1,N), 
     *                 ((FUNIT(I,J),I=1,N),J=1,NR),
     *                 ((FUNLOG(I,J),I=1,N),J=1,NR),
     *                 ((FUNCON(I,J),I=1,N),J=1,NR),
     *                 (LDISC(I),I=1,LDISC(1)+1),
     *                 LFMAX,
     *            (((LFUNIT(L,M,I),L=1,LFMAX),M=1,N),I=1,NR),
     *                 LRMAX,
     *            (((LRITB(L,M,I),L=1,LRMAX),M=1,N),I=1,N)
*
* 
      READ(FNR,REC=2)(((MUTAB(I,J,K),I=1,N),J=1,N),K=1,N)
*
*
*     
      IF ( FLAG .EQ. 1 ) CALL FLNFRE(FNR,*9999)
9999  CONTINUE               
      CALL END(*9998)
      RETURN
9998  RETURN1
      END
            
               
         

            
               
         


            
               
         
