      SUBROUTINE INITI4(MATRIX,DIMZ,N,VALUE,MODUS)
*
C     ******************************************************************
C     *                                                                *
C     *                    S U B R O U T I N E                         *
C     *                                                                *
C     *                        I N I T I 4                             *
C     *                                                                *
C     ******************************************************************
C
*DOC             initializaton of an integer matrix
**DOC
*INDEX  INITI4(BA/1): Initialization of an Integer Matrix
**DOC
**DOC   (1) DESCRIPTION IN DETAIL:
**DOC       Depending on MODUS the matrix MATRIX is covered all over
**DOC       with the same value or with a multiple of the unit matrix.
**DOC       Till now, the covering is only done for a square matrix.
**DOC
**DOC   (2) PARAMETER (IN):
**DOC       DIMZ   (INT)     Row dimension of MATRIX in calling routine
**DOC       N      (INT)     Number of rows/columns to cover
**DOC       MODUS  (INT)     = 1 Covering with VALUE*unit matrix
**DOC                        = 2 Covering of the whole matrix
**DOC       VALUE  (INT)     Value for the covering
**DOC
**DOC   (3) PARAMETER (OUT):
**DOC       MATRIX  (INT2)   Initializied matrix
**DOC
**DOC   (4) PARAMETER (IN/OUT):
**DOC       -
**DOC
**DOC   (5) MODIFICATIONS OF GLOBAL VARIABLES:
**DOC       -
**DOC
**DOC   (6) SUBROUTINES CALLED:
**DOC       -
**DOC
**DOC   (7) INCLUDE-FILES USED:
**DOC       -
**DOC
**DOC   (8) AUTHOR(S):
**DOC       JS       1987
**DOC
**DOC   (9) MODIFICATIONS:
**DOC       JS       29.03.88
**DOC
      INTEGER DIMZ, MATRIX(DIMZ,*),VALUE,MODUS,N
*
      GOTO (1,2) MODUS
*
1     DO 101 I=1,N
         DO 100 J=1,N
100         MATRIX(I,J) = 0
101      MATRIX(I,I) = VALUE
      RETURN
*
2     DO 102 I=1,N
        DO 102 J=1,N
102        MATRIX(I,J) = VALUE
*
      RETURN
      END
