      SUBROUTINE RREAD1(X,K)
*
C     ******************************************************************
C     *                                                                *
C     *                    S U B R O U T I N E                         *
C     *                                                                *
C     *                        R R E A D 1                             *
C     *                                                                *
C     ******************************************************************
C
*DOC             Reading of a long real number
**DOC
*INDEX  RREAD1(AM/2): Reading of a long real number
**DOC
**DOC   (1) DESCRIPTION IN DETAIL:
**DOC       The long real number X (which was written by RWRIT1) is 
**DOC       read from the file number K.
**DOC
**DOC   (2) PARAMETER (IN):
**DOC       K       (INT)       file number
**DOC
**DOC   (3) PARAMETER (OUT):
**DOC       X       (LDP)       long real number to read
**DOC
**DOC   (4) PARAMETER (IN/OUT):
**DOC       -
**DOC
**DOC   (5) MODIFICATIONS OF GLOBAL VARIABLES:
**DOC       -
**DOC
**DOC   (6) SUBROUTINES CALLED:
**DOC       -
**DOC
**DOC   (7) INCLUDE-FILES USED:
**DOC       -
**DOC
**DOC   (8) AUTHOR(S):
**DOC       FS       14.11.90
**DOC
**DOC   (9) MODIFICATIONS:
**DOC       -
**DOC
*
      INTEGER X(*), I, J, J0, K, LK, LM, LN
C
      READ(K,18) X(1), X(2)
C
      LN = IABS( X(2) )
      LM = INT(LN/10)
      LK = LN-10*LM
C
      IF ( LN.EQ.0 ) THEN
         READ(K,19) X(2)
         GOTO 9000
      ENDIF
C
      DO 10 I=1,LM
         J0=2+LN-10*(I-1)
         READ(K,17) (X(J0-J),J=0,9)
10    CONTINUE
C
20    IF (LK.EQ.0) GOTO 9000
C
      J0=2+LK
      READ(K,17) (X(J0-J),J=0,LK-1)
C
17    FORMAT(10(I8,1X))
18    FORMAT( 2(I8,1X))
19    FORMAT( 1(I8,1X))
C
9000  RETURN
      END
