/*  block_types.h

Define type numbers for inclusion in tracked block headers.

   W A R N I N G :
	You should only ever add to this list!  Deleting or changing entries
	may require a complete recompile of Cayley.
*/

#ifndef _BLOCK_TYPES_H_
#define _BLOCK_TYPES_H_

enum
{
    EMPTY_BLOCK_TYPE,
    ILIST_BLOCK_TYPE,
    INTBIG_BLOCK_TYPE,
    CYCLO_BLOCK_TYPE,
    CHTR_BLOCK_TYPE,
    QUAD_BLOCK_TYPE,
    POLY_BLOCK_TYPE,
    MAT_BLOCK_TYPE,
    RING_BLOCK_TYPE,
    VSPACE_BLOCK_TYPE,
    MODULE_BLOCK_TYPE,
    QMELT_BLOCK_TYPE,
    GRAPH_BLOCK_TYPE,
    GRAPH_SET_BLOCK_TYPE,
    GRAPH_PERM_BLOCK_TYPE,
    GRAPH_GENERAL_BLOCK_TYPE,
    GRAPH_LIST_BLOCK_TYPE,
    MP_BLOCK_TYPE,
    MP_ARRAY_BLOCK_TYPE,
    ANF_ELT_BLOCK_TYPE,
    ANF_BLOCK_TYPE,
    ANF_IDEAL_BLOCK_TYPE,
    ANF_CON_BLOCK_TYPE,
    MP_VECTOR_BLOCK_TYPE,
    PQ_SAVE_BLOCK_TYPE,
    RELATION_BLOCK_TYPE,
    REL_STR_BLOCK_TYPE,
    CODE_BLOCK_TYPE,
    BV_BLOCK_TYPE,
    DMAT_BLOCK_TYPE,
    CHTR_TABLE_BLOCK_TYPE,
    LATTICE_BLOCK_TYPE,
    LAT_ELT_BLOCK_TYPE,
    LAT_ENUM_ENV_BLOCK_TYPE,
    ANF_CEILING_BLOCK_TYPE,
    THUE_BLOCK_TYPE,
/* added by steve to fix errs after grabbing from sydney */
	DYN_ARR_BLOCK_TYPE,
	FACLST_BLOCK_TYPE,
	GRP_BLK_BLOCK_TYPE,
	LIX_ARRAY_BLOCK_TYPE,
	LIX_CONTEXT_BLOCK_TYPE,
	LIX_STACK_BLOCK_TYPE,
	LIX_TABLE_BLOCK_TYPE,
	MAP_BLOCK_TYPE,
	PRIME_CERT_BLOCK_TYPE,
	Q_BLOCK_TYPE,
	STRING_BLOCK_TYPE,
	WORD_LIST_BLOCK_TYPE
};

/* NB: do not use any type >= 0x8000 (this indicates it's a stack) */

#endif

#if 0

/* Integer package type */

/* Cyclotomic numbers */

/* Characters */

/* Quadratic field elements */

/* Polynomial package types */

/* Matrix package types */

/* Ring header type */

/* Vector space type */


/* Cyclotomic number type */

/* Graph package types */





/* MP type */

/* MP array type */

/* Algebraic Number type */

/* Algebraic Number Field type */

/* Algebraic Number Field Ideal type */

/* Conjugates of algebraic Number type */

/* MP vector type */

/* PQ save type */

/* Relation type */

/* Relation structure type */

/* Code type */

/* Bit vector type  - bit vectors are in the poly directory. */

/* Double Matrix type */

#endif
